sampler sourceTexture: register(s0);
sampler velocityTexture: register(s1);
sampler prevVelocityTexture: register(s2);

int NumberOfPostProcessSamples;
float PixelBlurConst;

void getFirstDepthBlurPS(in float4 texCoord7In: TEXCOORD7,
						 in float4 texCoord0In: TEXCOORD0,
			    in float3 normalIn : NORMAL, 
			    out float4 texCoord7Out: r_texCoord7,
				out float4 texCoord0Out: r_texCoord0,
			    out float3 normalWorld: r_normalWorld) {
	texCoord7Out = texCoord7In;
	texCoord0Out = texCoord0In;
	normalWorld = normalIn;
}

pixelfragment psFirstDepthBlur = compile_fragment ps_3_0 getFirstDepthBlurPS();

void getSecondDepthBlurPS(in float4 texCoord7: TEXCOORD7,
						  in float4 texCoord6: TEXCOORD6,
						  in float4 texCoord0: r_texCoord0,
						 in float3 normalWorld: r_normalWorld,
						 out float4 outColor: COLOR) {

	outColor = float4(texCoord7.xy/texCoord7.w - texCoord6.xy/texCoord6.w, texCoord7.z, 1);//texCoord7;
}

pixelfragment psSecondDepthBlur = compile_fragment ps_3_0 getSecondDepthBlurPS();