sampler u;

uniform float dt;
uniform float2 invDim;
uniform float2 dim;

uniform float2 force;
uniform float2 impulsePos;
uniform float impulseRadius;

float2 texBilerpRG(sampler tex, float2 s) {
  float4 st;
  st.xy = floor(dim*(s+invDim) - 0.5) + 0.5;
  st.zw = st.xy + 1;
  
  float2 t = invDim*(dim*(s+0.375f*invDim) - st.xy); //interpolating factors 
    
  float2 tex11 = tex2D(tex, invDim*st.xy).rg;
  float2 tex21 = tex2D(tex, invDim*st.zy).rg;
  float2 tex12 = tex2D(tex, invDim*st.xw).rg;
  float2 tex22 = tex2D(tex, invDim*st.zw).rg;

  // bilinear interpolation
  return lerp(lerp(tex11, tex21, t.x), lerp(tex12, tex22, t.x), t.y);
}

/*void getAddForcePS(in float4 texCoord0: TEXCOORD0,
				 out float2 color: COLOR0) {
	
    float2 dist = texCoord0.xy/texCoord0.w - impulsePos;
	float intensity = exp(-(dist.x*dist.x + dist.y*dist.y)/impulseRadius);
	color = float4(texBilerpRG(u, texCoord0.xy/texCoord0.w) + force*dt*intensity, 0, 1);
}*/

void getAddForcePS(in float4 texCoord0: TEXCOORD0,
				 out float2 color: COLOR0/*,
				 out float4 color1: COLOR1*/) {
	
    float2 dist = texCoord0.xy/texCoord0.w - impulsePos;
	float intensity = exp(-(dist.x*dist.x + dist.y*dist.y)/impulseRadius);
	color = tex2D(u, texCoord0.xy/texCoord0.w).rg + force*dt*intensity;
}

pixelfragment fluidAddForcePS = compile_fragment ps_3_0 getAddForcePS();