sampler aTex;

uniform float2 force;
uniform float2 impulsePos;
uniform float impulseRadius;
uniform float3 inkColor;

void getAddInkPS(in float4 texCoord0: TEXCOORD0,
				 out float4 color: COLOR0) {
	
    float2 dist = texCoord0.xy - impulsePos;
	float intensity = exp(-(dist.x*dist.x + dist.y*dist.y)/impulseRadius);
	color = tex2D(aTex, texCoord0.xy) + float4(inkColor*10*intensity, 1);
}

pixelfragment fluidAddInkPS = compile_fragment ps_3_0 getAddInkPS();