sampler u;
sampler x;

uniform float dt;
uniform float2 invDim;
uniform float2 dim;

float4 texBilerpRGBA(sampler tex, float2 s) {
  float4 st;
  st.xy = floor(dim*(s+invDim) - 0.5) + 0.5;
  st.zw = st.xy + 1;
  
  float2 t = invDim*(dim*(s+0.375f*invDim) - st.xy); //interpolating factors 
    
  float4 tex11 = tex2D(tex, invDim*st.xy);
  float4 tex21 = tex2D(tex, invDim*st.zy);
  float4 tex12 = tex2D(tex, invDim*st.xw);
  float4 tex22 = tex2D(tex, invDim*st.zw);

  // bilinear interpolation
  return lerp(lerp(tex11, tex21, t.x), lerp(tex12, tex22, t.x), t.y);
}

/*void getAdvectPS(in float4 texCoord0: TEXCOORD0,
				 out float4 color: COLOR0) {
	
	// follow the velocity field "back in time"
	//float2 pos = texCoord0.xy - dt * invDim * tex2D(u, texCoord0.xy).rg;
	float2 pos = (texCoord0.xy - dt*invDim*texBilerpRGBA(u, texCoord0.xy).rg);
	
	// interpolate and write to the output fragment
	color = texBilerpRGBA(x, pos);
}*/

void getAdvectPS(in float4 texCoord0: TEXCOORD0,
				 out float4 color: COLOR0) {
	
	// follow the velocity field "back in time"
	//float2 pos = texCoord0.xy - dt * invDim * tex2D(u, texCoord0.xy).rg;
	float2 pos = (texCoord0.xy - dt*invDim*tex2D(u, texCoord0.xy).rg);
	
	// interpolate and write to the output fragment
	color = tex2D(x, pos);
}

pixelfragment fluidAdvectPS = compile_fragment ps_3_0 getAdvectPS();
