sampler x;

uniform float2 invDim;
uniform float2 dim;
uniform float scale;

float4 texBilerpRGBA(sampler tex, float2 s) {
  float4 st;
  st.xy = floor(dim*(s+invDim) - 0.5) + 0.5;
  st.zw = st.xy + 1;
  
  float2 t = invDim*(dim*(s+0.375f*invDim) - st.xy); //interpolating factors 
    
  float4 tex11 = tex2D(tex, invDim*st.xy);
  float4 tex21 = tex2D(tex, invDim*st.zy);
  float4 tex12 = tex2D(tex, invDim*st.xw);
  float4 tex22 = tex2D(tex, invDim*st.zw);

  // bilinear interpolation
  return lerp(lerp(tex11, tex21, t.x), lerp(tex12, tex22, t.x), t.y);
}

void getBoundariesPS(in float4 texCoord0: TEXCOORD0,
				 out float4 color: COLOR0) {
	
    color = scale * tex2D(x, texCoord0.xy);
}

pixelfragment fluidBoundariesPS = compile_fragment ps_3_0 getBoundariesPS();