sampler w; // vector field

uniform float2 invDim;
uniform float2 dim;
uniform float halfrdx; // 0.5 / gridscale


float2 texBilerpRG(sampler tex, float2 s) {
  float4 st;
  st.xy = floor(dim*(s+invDim) - 0.5) + 0.5;
  st.zw = st.xy + 1;
  float2 temps = s+0.375f*invDim;
  float2 t = invDim*(dim*temps - st.xy); //interpolating factors 
    
  float2 tex11 = tex2D(tex, invDim*st.xy).rg;
  float2 tex21 = tex2D(tex, invDim*st.zy).rg;
  float2 tex12 = tex2D(tex, invDim*st.xw).rg;
  float2 tex22 = tex2D(tex, invDim*st.zw).rg;

  // bilinear interpolation
  return lerp(lerp(tex11, tex21, t.x), lerp(tex12, tex22, t.x), t.y);
}

/*void getDivergence(in float4 coords : TEXCOORD0, // grid coordinates
					out float2 div : COLOR0)
{
	float wL = texBilerpRG(w, coords - float2(invDim.x, 0)).r;
	float wR = texBilerpRG(w, coords + float2(invDim.x, 0)).r;
	float wB = texBilerpRG(w, coords - float2(0, invDim.y)).g;
	float wT = texBilerpRG(w, coords + float2(0, invDim.y)).g;
	
	//div = ((wR.x - wL.x) + (wT.y - wB.y));
	div.rg = ((wR - wL) + (wT - wB));
}*/

void getDivergence(in float4 coords : TEXCOORD0, // grid coordinates
					out float2 div : COLOR0)
{
	float wL = tex2D(w, coords - float2(invDim.x, 0)).r;
	float wR = tex2D(w, coords + float2(invDim.x, 0)).r;
	float wB = tex2D(w, coords - float2(0, invDim.y)).g;
	float wT = tex2D(w, coords + float2(0, invDim.y)).g;
	
	//div = ((wR.x - wL.x) + (wT.y - wB.y));
	div.rg = ((wR - wL) + (wT - wB));
}

pixelfragment fluidDivergencePS = compile_fragment ps_3_0 getDivergence();
