sampler tex;


void getMicroscopyColor(in float4 texCoord0: r_texCoord0,
					 in float3 normalWorld: r_normalWorld,
					 in float4 viewVector: TEXCOORD5,
					 out float4 outColor: COLOR,
					 out float4 matColor: r_matColor) {
	float4 ccolor=tex2D(tex,float2(texCoord0.x,texCoord0.y));

	float alpha=1-abs(dot((float3)viewVector,normalWorld));
	//float zufall = frac( texCoord0.x * 13.57f + texCoord0.y * 18.39f);
	//float zufall = 1+frac(100*texCoord0.x*texCoord0.y*0.618034);
	alpha=alpha*alpha;//*zufall;
	ccolor+=alpha;
	ccolor.a=1-alpha*0.2;
	/*float schwellwert=alpha*alpha*zufall;
	if (schwellwert>=0.7) {
		ccolor=0;
	}*/
	//float n=noise(float2(4.0,3.0));//float3(texCoord0.x,texCoord0.y,texCoord0.z));
	ccolor.r=min(1.0,ccolor.x);
	ccolor.g=min(1.0,ccolor.y);
	ccolor.b=min(1.0,ccolor.z);
	ccolor.a=1.0;//max(0.0,ccolor.a);

	matColor=ccolor;

	outColor=ccolor;
}

pixelfragment psMicroscopyColor = compile_fragment ps_3_0 getMicroscopyColor();