sampler diffuseTex;
sampler normalTex;

float4x4 worldMat;

void getNormalMicroscopyColor(in float4 texCoord0: r_texCoord0,
					// in float3 normalWorld: r_normalWorld,
					 in float4 texCoord1: TEXCOORD1,
					 in float4 texCoord2: TEXCOORD2,
					 in float4 texCoord3: TEXCOORD3,
					 in float4 viewVector: TEXCOORD5,
					 out float4 outColor: COLOR,
					 out float4 matColor: r_matColor) {

	// Normalmapping

	float3x3 tbnMatrix=float3x3(texCoord1.xyz, texCoord2.xyz, texCoord3.xyz);

	float3 normalWorld=2.0*(tex2D(normalTex, texCoord0.xy).rgb-0.5);
	normalWorld=normalize(mul(mul( normalWorld, tbnMatrix ),(float3x3) worldMat ));
	//normalWorld=normalize(mul( normalWorld, tbnMatrix ));

	// Normal fertig


	float4 ccolor=tex2D(diffuseTex,float2(texCoord0.x,texCoord0.y));

	float alpha=1-abs(dot((float3)viewVector,normalWorld));
	//float zufall = frac( texCoord0.x * 13.57f + texCoord0.y * 18.39f);
	//float zufall = 1+frac(100*texCoord0.x*texCoord0.y*0.618034);
	alpha=alpha*alpha;//*zufall;
	ccolor+=alpha;
	ccolor.a=1-alpha*0.2;
	/*float schwellwert=alpha*alpha*zufall;
	if (schwellwert>=0.7) {
		ccolor=0;
	}*/
	//float n=noise(float2(4.0,3.0));//float3(texCoord0.x,texCoord0.y,texCoord0.z));
	ccolor.r=min(1.0,ccolor.x);
	ccolor.g=min(1.0,ccolor.y);
	ccolor.b=min(1.0,ccolor.z);
	ccolor.a=1.0;//max(0.0,ccolor.a);


	//ccolor=float4(normalWorld,1.0);

	matColor=ccolor;

	outColor=ccolor;


}

pixelfragment psNormalMicroscopyColor = compile_fragment ps_3_0 getNormalMicroscopyColor();