#define PI 3.14159265f
#define invPI 0.31830988f

float4 cameraPos;
float4 spherePos;
float sphereRadius;
float invFarMinusNear;
float4x4 worldMat;
float4x4 viewProjMatT;

void calcSphere(in out float4 texCoord0: r_texCoord0,
				in out float3 normalWorld: r_normalWorld,
				//in out float4 texCoord6: r_texCoord6,
				out float depthOut: r_depth,
			    out float depth: DEPTH) {

	depthOut = 0.0f;

	float3 dir = texCoord0.xyz - cameraPos.xyz;
	//dir = normalize(dir);
	
	float3 cameraMinusSphere = cameraPos.xyz - spherePos.xyz;
	//cameraMinusSphere*=-1;

	//Compute A, B and C coefficients
    float a = dot(dir, dir);
	float b = 2*dot(dir, cameraMinusSphere);
	float c = dot(cameraMinusSphere, cameraMinusSphere) - sphereRadius*sphereRadius;


	float disc = b*b - 4*a*c;
	if(disc>=0) {
		float t = (-b - sqrt(disc))/(2*a);
		float3 pos = cameraPos + t*dir;
		float4 tpos = float4(pos.x, pos.y, pos.z, 1);
		tpos = mul(viewProjMatT, tpos);
		//depthOut = tpos.z;
		depth = tpos.z/tpos.w;
		depthOut = tpos.z*invFarMinusNear;

		/*float tempf = length(pos - spherePos)*invSphereRadius;
		float oneMinusTempf = 1.0f-tempf;
		depth = (zBack/wBack)*oneMinusTempf + (zFront/wFront)*tempf;*/

		//calc normal
		normalWorld = pos - spherePos.xyz;
		normalWorld = mul(normalWorld, (float3x3) worldMat);

		//texCoord6 = float4(t*dir, 1);

		//normalWorld = mul( normalWorld, transpose((float3x3) invWorldView));
		normalWorld = normalize(normalWorld);

		//calc uv coordinates
		texCoord0.x = atan2(normalWorld.x, normalWorld.z)*invPI*0.5f + 0.5f;
		texCoord0.y = normalWorld.y*0.5f + 0.5f;
	} else {
		depth = 1.1f;
	}
}

pixelfragment psSphere = compile_fragment ps_3_0 calcSphere();
