sampler2D randNormalTex;
sampler2D normalDepthTex;
sampler2D sourceTex;
float4 spherePoints[32];
float rad;
float invFarMinusNearPlane;

void psDoSSAO(in float4 texCoord0: TEXCOORD0,
			  out float4 outColor: COLOR) {
	
					  
    float normalDepth = tex2D( normalDepthTex, texCoord0.xy ).r;

	float4 plane = tex2D( randNormalTex, texCoord0.xy);
	plane.xyz = normalize(plane.xyz*2.0f - 1.0f);

    float finalAmbientFactor = 0.0f;
	float maxRadius = 0.25f;
	int maxLookups = 16;
    for( int i=0; i<maxLookups; i++ )
    {
		float2 duv = maxRadius*reflect(spherePoints[i].xyz, plane.xyz).xy;
		float depth1 = tex2D(normalDepthTex, texCoord0.xy + duv).r;
		float depth2 = tex2D(normalDepthTex, texCoord0.xy - duv).r;

		float maxDiff = 1000.0f*max(normalDepth - depth1, normalDepth - depth2);
		float factor = 1000.0f*1.0f/(1.0f+maxDiff*maxDiff);

		float dz = factor*max(normalDepth - (depth1 + depth2)*0.5f, 0);
		finalAmbientFactor += 1.0f/(1.0f+30.0f*dz*dz);
	}
	finalAmbientFactor /= maxLookups;
	//outColor = float4(finalAmbientFactor.xxx, 1);
	
	outColor = tex2D(sourceTex, texCoord0.xy)*finalAmbientFactor.x;
	//outColor = float4(normalDepth.xxx, 1);


	/*float4 color = abs(tex2D(sourceTex, texCoord0.xy));
	color.rg*=18.0f;
	color.b = 0.0f;
	outColor = color*finalAmbientFactor.x;*/

	//pressure
	/*float color = tex2D(sourceTex, texCoord0.xy).r;
	color *=30.0f;
	outColor = float4(color, 0, 1-color,1)*finalAmbientFactor.x;*/
}

pixelfragment psSSAO = compile_fragment ps_3_0 psDoSSAO();