sampler tex;
float4 lightColor;
float4 ambientFactor;
float shininess;
float specularFactor;


void firstStdPS(in float4 texCoord0In: TEXCOORD0,
			    in float3 normalIn : NORMAL, 
			    out float4 texCoord0Out: r_texCoord0,
			    out float3 normalWorld: r_normalWorld) {
	texCoord0Out = texCoord0In;
	normalWorld = normalIn;
}

pixelfragment psStdFirst = compile_fragment ps_3_0 firstStdPS();

void getColor(in float4 texCoord0: r_texCoord0,
			  in float3 normalWorld: r_normalWorld,
			in float4 lightDir: TEXCOORD4,
			  out float4 matColor: r_matColor,
			  out float4 outColor: COLOR0) {

	/*float3 ccolor = float3(0.4*texCoord0.x/texCoord0.x, 0.8, 1);
	float3 li = float3(1, -0.75, 0);
	li = normalize(li);
	//float3 normal = float3(normalWorld.x, normalWorld.y, normalWorld.z);
	float ambient = max(dot(li, normalWorld), 0);
	ccolor = ccolor*ambient;*/

	matColor = float4(0.5, 0.75f, 0.25f, 1);
	//matColor = max(dot(lightDir.xyz, normalWorld), 0)*matColor;
	outColor = matColor;
	//outColor = float4((normalWorld.x+1)*0.5, (normalWorld.y+1)*0.5, (normalWorld.z+1)*0.5*texCoord0.x/texCoord0.x,1);
	//outColor = float4(texCoord0.x, texCoord0.y, 0, 1);
}

pixelfragment psColor = compile_fragment ps_3_0 getColor();

void getTextureColor(in float4 texCoord0: r_texCoord0,
					 in float3 normalWorld: r_normalWorld,
					 in float4 lightDir: TEXCOORD4,
					 in float4 viewVector: TEXCOORD5,
					 out float4 outColor: COLOR0,
					 out float4 matColor: r_matColor) {

	//outColor=float4(1.0,1.0,0.0,1.0);//tex2D(tex,float2(texCoord0.x,texCoord0.y));

	//float4 color=float4(0, 1, 0, 1);//tex2D(tex,texCoord0.xy);
	float4 color= tex2D(tex,texCoord0.xy);

	float4 ambientColor=ambientFactor*color;
	ambientColor.a=1.0;

	float4 diffuseColor  = color* lightColor * max(0.0, dot(normalWorld, lightDir.xyz));
	diffuseColor.a=1.0;

	float3 halfV=reflect(lightDir.xyz,normalWorld);

	float specularPower=pow(max(0.0, -dot(halfV, viewVector.xyz)), shininess);
	float4 specularColor=lightColor*specularPower*specularFactor;
	specularColor.a=1.0;


	outColor=saturate(ambientColor+diffuseColor+specularColor);//dot(lightDir.xyz, normalWorld)*tex2D(tex,texCoord0.xy);
	//outColor=saturate(diffuseColor);
	//outColor=tex2D(tex,texCoord0.xy);
	//outColor = color;
	matColor = outColor;
}

pixelfragment psTextureColor = compile_fragment ps_3_0 getTextureColor();