sampler3D densityTex;
sampler2D backfaceTex;
sampler2D transferTex;
int maxDim;
int sw;
int sh;
float4x4 worldMat;

float slimeFactor;
float slimeX;
float rotation;

float invFarMinusNear;

float3 getSlimeCoords(float3 texCoords)
{
	float k;

	k=10.0*slimeFactor*(cos(slimeX+texCoords.z*10.0*(slimeFactor-0.5))+1.0);

	float3 result;
	result = texCoords;
	
	//Rotation
	float cosTerm = cos(2*3.1415*texCoords.z*rotation);
	float sinTerm = sin(2*3.1415*texCoords.z*rotation);

	result.x = (texCoords.x - 0.5f)*cosTerm - (texCoords.y - 0.5f)*sinTerm + 0.5f;
	result.y = (texCoords.y - 0.5f)*cosTerm + (texCoords.x - 0.5f)*sinTerm + 0.5f;

	//Scale
	result.x=result.x+k*(result.x-0.5);
	result.y=result.y+k*(result.y-0.5);
	result.z=result.z+k*(result.z-0.5);


	return result;
}

void getVolume(in float4 texCoord0: TEXCOORD0,
			   in float4 pos: TEXCOORD1,
			   in float2 fragpos: VPOS,
			   in float4 depth: TEXCOORD2,
				out float4 outColor: COLOR0,
				out float4 outDepth: COLOR1,
				out float realDepth: DEPTH) {

//******************************

	float startSampleRate=2.0;
	float sampleRate=startSampleRate;
	float startLowSampleRate=0.4;
	float lowSampleRate=startLowSampleRate;
	
	int hit=0;
	
	float alphaPow=0.0;
 
	float4 endPos=tex2D(backfaceTex, float2(fragpos.x/sw, fragpos.y/sh)).rgba;
	float3 startPos=texCoord0.xyz;
	float3 totalTraceDir=endPos.rgb-startPos;
	float traceLength=length(totalTraceDir);
	float3 traceDir=totalTraceDir/(float(maxDim)*sampleRate);		// stepsize muss vom datensatz abhaengen
	float stepLength=length(traceDir);
	float4 color=float4(0.0,0.0,0.0,0.0);
	
	float accAlpha=0.0;
	
	float currentLength=0.0;
	float3 currentPos=startPos;
	float4 currentColor;

	float3 slimeCoords;
	
	float maxDensity=0.0;
	float curDensity=0.0;
	float3 curNormal=float3(1.0,0.0,0.0);
	
	//vec3 lightVec=normalize(vec3(1.0,1.0,1.0));
	float3 lightVec=float3(0.57735,0.57735,0.57735);
	float3 halfVec=float3(1.0,0.0,0.0);
	
	float diffuse=0.0;
	float shininess=2.0;
	float ambientFactor=0.2;
	float specularFactor=0.5;
	
	float specular=0.0;
	float borderline=0.0;

	float depthLen=0.0;
	
	float3 viewVec=normalize(-pos.xyz);

	int i=0;

	float transferOffset=slimeX*0.02;//%4;//(sin(slimeX*0.2)+1.0)*0.5;
	
	while (currentLength<traceLength && accAlpha<0.9 && i<1024) {
		
		//curDensity=tex3Dlod(densityTex, float4(currentPos,0)).r;
		slimeCoords=getSlimeCoords(currentPos);
		if (slimeCoords.x<=1.0 && slimeCoords.y<=1.0 && slimeCoords.z<=1.0 && slimeCoords.x>=0.0 && slimeCoords.y>=0.0 && slimeCoords.z>=0.0) {
			curDensity=tex3Dlod(densityTex, float4(slimeCoords,0)).r;
			currentColor=float4(tex2Dlod(transferTex, float4(curDensity, transferOffset,0.0,0.0)));
		} else {
			currentColor=float4(0.0,0.0,0.0,0.0);
		}
		//currentColor=float4(curDensity,curDensity,curDensity,curDensity);//float4(tex2D(transferTex, float2(curDensity, 0.75)));
		//currentColor=float4(tex2Dlod(transferTex, float4(curDensity,0.0, 0.75,0.0)));
		
		//if (currentColor.a>0.0 && currentLength>startSlice) {
		if (currentColor.a>0.01 || borderline>0.0) {
			if (hit==0) {
				borderline=stepLength;
				currentPos-=traceDir;
				currentLength-=stepLength;
				//curDensity=tex3Dlod(densityTex, float4(currentPos,0)).r;
				slimeCoords=getSlimeCoords(currentPos);
				//currentColor=float4(curDensity,curDensity,curDensity,curDensity);//float4(tex2D(transferTex, float2(curDensity, 0.75)));
				if (slimeCoords.x<=1.0 && slimeCoords.y<=1.0 && slimeCoords.z<=1.0 && slimeCoords.x>=0.0 && slimeCoords.y>=0.0 && slimeCoords.z>=0.0) {
					curDensity=tex3Dlod(densityTex, float4(slimeCoords,0)).r;
					currentColor=float4(tex2Dlod(transferTex, float4(curDensity, transferOffset,0.0,0.0)));
				} else {
					currentColor=float4(0.0,0.0,0.0,0.0);
				}
				
				traceDir=totalTraceDir/(float(maxDim)*sampleRate);		// stepsize muss vom datensatz abhaengen
				stepLength=length(traceDir);
			}
		
			hit=1;
			
			
			borderline-=stepLength;
		


//			curNormal=tex3Dlod(densityTex, float4(currentPos,0)).gba*2.0-1.0;
			curNormal=tex3Dlod(densityTex, float4(slimeCoords,0)).gba*2.0-1.0;
			curNormal=mul( curNormal, (float3x3) worldMat );
		
			diffuse=max(0.0,dot(curNormal,lightVec));
			
			halfVec=reflect(-lightVec,curNormal);
			
			specular=specularFactor*pow(max(0.0, dot(halfVec, viewVec)),shininess);
			
			currentColor.rgb=currentColor.rgb*diffuse+currentColor.rgb*ambientFactor;
			currentColor.rgb+=specular;
			
			//color = vec4(color.rgb*(1.0-currentColor.a),1.0) + vec4(currentColor.rgb*currentColor.a, 1.0);
			color =float4(color.rgb+(1.0-accAlpha)*currentColor.rgb*currentColor.a/sampleRate,accAlpha);
		
			accAlpha+=(1.0-accAlpha)*currentColor.a/sampleRate;

			if (accAlpha>=0.5 && depthLen==0.0) {
				depthLen=currentLength;
			}
		} else {
			hit=0;
			traceDir=totalTraceDir/(float(maxDim)*lowSampleRate);
			stepLength=length(traceDir);
		}
	
	/*	alphaPow=pow(accAlpha,4.0);
		sampleRate=startSampleRate-alphaPow*startSampleRate;
		lowSampleRate=startLowSampleRate-alphaPow*startLowSampleRate;*/
	
		currentPos+=traceDir;
		currentLength+=stepLength;

		i++;
	}
	
	//color=vec4(maxDensity,maxDensity,maxDensity,traceLength);
	//color=vec4(texture2D(transferTex, vec2(maxDensity, 0.75)));

	//color=vec4(traceDir.x,traceDir.y,traceDir.z,1.0);

	//outColor=endPos;
	outColor=color;

	float resultDepth=1.1;
	if (traceLength>0.0 && depthLen>0.0) {
		resultDepth=depth.x;//+(endPos.a-depth.x)*depthLen/traceLength;
		outDepth=float4(resultDepth, 0, 0, 1);//float2(resultDepth,1.0);
		realDepth = depth.b/depth.w;
	} else {
		realDepth = 1.1;
		outDepth=float4(1.1, 0, 0, 0);//float2(0.0,0.0);
	}
	//realDepth = depth.b;///depth.w;
	//outDepth=float2(1.0,1.0);

	//outColor=float4(endPos.a*20,endPos.a*20,endPos.a*20,1.0);



//*****************************







	//outColor=float4(0.0,0.0,1.0,1.0);
	//outColor=tex3D(densityTex,texCoord0.xyz).rrrr;
	//outColor=float4(texCoord0.xyz,1.0);
}

pixelfragment psVolume = compile_fragment ps_3_0 getVolume();