//------------------------------------
float4x4 worldMat;
float4x4 worldViewProjMat;
float invFarMinusNear;

//------------------------------------
//Do just simply copy the position and normal to shared register
void getFirstNormalDepthVS(in float4 pos: POSITION,
					   in float4 texCoord0: TEXCOORD0,
					   in float4 texCoord7: TEXCOORD7,
					   out float4 posVertex: r_posVertex,
					   out float4 texCoord0Out: r_texCoord0,
					   out float4 texCoord7Out: r_texCoord7) 
{
	posVertex = pos;
	texCoord0Out = texCoord0;
	texCoord7Out = texCoord7;
}

vertexfragment firstNormalDepthVS = compile_fragment vs_3_0 getFirstNormalDepthVS();


//Perform projection of pos and normal
void getSecondNormalDepthVS(in float4 posVertex: r_posVertex,
						in float4 texCoord0: r_texCoord0,
						in float4 texCoord7: r_texCoord7,
						out float4 hpos: POSITION,
						out float4 texCoord0Out: TEXCOORD0,
						out float4 texCoord7Out: TEXCOORD7) {

	hpos = mul(posVertex, worldViewProjMat);
    
	texCoord0Out = texCoord0;
	texCoord7Out = float4(hpos.zzz*invFarMinusNear, hpos.w);
}

vertexfragment secondNormalDepthVS = compile_fragment vs_3_0 getSecondNormalDepthVS();
 