//------------------------------------
float4 cameraPos;
float4x4 worldMat;
float4x4 worldViewProjMat;

void normalMicroscopy_VS(in float4 posVertex: r_posVertex,
				in float3 normal: r_normal,
				in float4 texCoord0: r_texCoord0,
				in float4 texCoord1: TEXCOORD1,
				in float4 texCoord2: TEXCOORD2,
				in float4 texCoord3: TEXCOORD3,
				out float4 hpos: POSITION,
				out float4 viewVector: TEXCOORD5,
				out float3 normalWorld: NORMAL,
				out float4 texCoord0Out: TEXCOORD0,
				out float4 texCoord1Out: TEXCOORD1,
				out float4 texCoord2Out: TEXCOORD2,
				out float4 texCoord3Out: TEXCOORD3) {

	hpos = mul( posVertex, worldViewProjMat );

	viewVector=float4(normalize(mul(posVertex, worldMat)-cameraPos.xyz),1.0);

    normalWorld = mul( normal, (float3x3) worldMat );
    texCoord0Out = texCoord0;//float4(texCoord0, 0, 1);

	texCoord1Out=texCoord1;
	texCoord2Out=texCoord2;
	texCoord3Out=texCoord3;
}

vertexfragment normalMicroscopyVS = compile_fragment vs_3_0 normalMicroscopy_VS();
 