//------------------------------------
float4 cameraPos;
float4x4 worldMat;
float4x4 worldViewProjMat;
float4x4 inverseWorldMat;

float invFarMinusNear;

void parallax_VS(in float4 posVertex: r_posVertex,
				in float4 texCoord0: r_texCoord0,
				in float4 texCoord1: TEXCOORD1,
				in float4 texCoord2: TEXCOORD2,
				in float4 texCoord3: TEXCOORD3,
				out float4 hpos: POSITION,
				out float4 viewVector: TEXCOORD6,
				out float3 viewTangent: TEXCOORD5,
				out float4 texCoord0Out: TEXCOORD0,
				out float4 texCoord1Out: TEXCOORD1,
				out float4 texCoord2Out: TEXCOORD2,
				out float4 texCoord3Out: TEXCOORD3,
				out float4 depth: TEXCOORD4) {

	hpos = mul( posVertex, worldViewProjMat );

	depth=float4(hpos.z*invFarMinusNear,0.0,0.0,0.0);

	float3x3 tbnMatrix=float3x3(texCoord1.xyz, texCoord2.xyz, texCoord3.xyz);
	float3x3 iTbnMatrix=transpose(tbnMatrix);

	viewVector=float4(normalize(mul(posVertex, worldMat)-cameraPos.xyz),1.0);

	cameraPos=mul(cameraPos, inverseWorldMat);
	viewTangent=mul(cameraPos.xyz-posVertex, iTbnMatrix );

    texCoord0Out = texCoord0;
	texCoord1Out=texCoord1;
	texCoord2Out=texCoord2;
	texCoord3Out=texCoord3;
}

vertexfragment parallaxVS = compile_fragment vs_3_0 parallax_VS();
 