int nbSlices;
float zDimension;
float zMin;
texture dataTexture;


/*#define SAMPLER_POINT(g_samplerMap, g_txMap);	\
	sampler2D g_samplerMap = sampler_state {	\
    Texture = <g_txMap>;						\
    MinFilter = Point;							\
    MagFilter = Point;							\
    MipFilter = Point;							\
    AddressU  = BORDER;							\
    AddressV  = BORDER;							\
};*/

//SAMPLER_POINT(samplerData,	dataTexture);
sampler samplerData:s257;


//Perform spline alignment
void getPosition(in float4 pos: r_posVertex,
				 in float3 normalIn: r_normal,
				 out float3 normalOut: r_normal,
				 out float4 npos: r_posVertex) {

	//Calculate lookupId
	int lookupId = (int) (((float) (nbSlices-1))*(pos.z - zMin)/zDimension);

	//Setup matrix
	float yStepSize = 1.0f/nbSlices;
	float yOffset = yStepSize*0.5f;

	float xStepSize = 0.25f;
	float xOffset = 0.125f;

	float4x4 sliceMat;

	for(int i=0;i<4;i++) {
		float4 row = tex2Dlod(samplerData, float4(xOffset+xStepSize*i, 1.0f - (yOffset+lookupId*yStepSize), 0, 1));
		sliceMat[i] = row;
	}
	pos.z = 0;
	npos = mul(pos, sliceMat);
	normalOut = mul(normalIn, (float3x3) sliceMat);
}

vertexfragment splineAlignment = compile_fragment vs_3_0 getPosition();