//------------------------------------
float4x4 worldMat;
float4x4 worldViewProjMat;
float4 lightPos;
float4 cameraPos;

//------------------------------------
//Do just simply copy the position and normal to shared register
void firstT0VS(in float4 pos: POSITION,
               in float3 normal: NORMAL,
               in float4 texCoord0: TEXCOORD0,
               out float4 posVertex: r_posVertex,
               out float3 normalOut: r_normal,
               /*out float4 vPosProj: POSITION,*/
               out float4 texCoord0Out: r_texCoord0) 
{
	posVertex = pos;
	normalOut = normalize(normal);
	texCoord0Out = texCoord0;
	//normalOut.x = 0.5f;
}

vertexfragment firstVS = compile_fragment vs_3_0 firstT0VS();


//Perform projection of pos and normal
void secondT0VS(in float4 posVertex: r_posVertex,
				in float3 normal: r_normal,
				in float4 texCoord0: r_texCoord0,
				out float4 hpos: POSITION,
				out float3 normalWorld: NORMAL,
				out float4 texCoord0Out: TEXCOORD0,
				out float4 texCoord4Out: TEXCOORD4,
				out float4 texCoord5Out: TEXCOORD5) {

	//hpos = posVertex; 
	hpos = mul( posVertex, worldViewProjMat );
	float4 wpos = mul( posVertex, worldMat);
    float3 lightDir = lightPos.xyz-wpos.xyz;
	float3 viewDir = cameraPos.xyz-wpos.xyz;
	lightDir = normalize(lightDir);
	viewDir=normalize(viewDir);
    // Transform the normal into world space for lighting
    normalWorld = mul( normal, (float3x3) worldMat );
    // Pass the texture coordinate
    //texCoord0Out = float4(texCoord0, 0, 1);
	texCoord0Out = texCoord0;
	texCoord4Out = float4(lightDir,1);
	texCoord5Out=float4(viewDir,1.0);
}

vertexfragment secondVS = compile_fragment vs_3_0 secondT0VS();
 